package com.company.example.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;
import lombok.Getter;
import lombok.Setter;

@JmixEntity
@Table(name = "TRZ_USE_AGREEMENT", indexes = {
        @Index(name = "IDX_TRZ_USE_AGREEMENT_AGREEMENT", columnList = "AGREEMENT_ID")
})
@Entity(name = "trz_UseAgreement")
@Getter
@Setter
public class UseAgreement extends Tracking {

    @Column(name = "IDENTIFICATION", nullable = false, length = 40)
    @NotNull
    private String identification;

    @InstanceName
    @Column(name = "NAME_", nullable = false)
    @NotNull
    private String name;

    @Column(name = "HIDDEN")
    private Boolean hidden = false;

    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "AGREEMENT_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private RefersFile agreement;
}