package com.company.example.view.useagreement;

import java.util.Objects;
import java.util.UUID;

import com.company.example.app.RefersFileService;
import com.company.example.entity.UseAgreement;
import com.company.example.view.main.MainView;
import com.vaadin.flow.component.AbstractField;
import com.vaadin.flow.router.Route;
import io.jmix.core.FileRef;
import io.jmix.flowui.component.upload.FileStorageUploadField;
import io.jmix.flowui.kit.component.upload.event.FileUploadSucceededEvent;
import io.jmix.flowui.view.*;
import lombok.RequiredArgsConstructor;

@Route(value = "use-agreements/:id", layout = MainView.class)
@ViewController("trz_UseAgreement.detail")
@ViewDescriptor("use-agreement-detail-view.xml")
@EditedEntityContainer("useAgreementDc")
@DialogMode(width = "52em")
@RequiredArgsConstructor
public class UseAgreementDetailView extends StandardDetailView<UseAgreement> {

    private final RefersFileService refersFileService;

    @ViewComponent
    private FileStorageUploadField fileField;

    @Subscribe("fileField")
    public void onFileFieldFileUploadSucceeded(final FileUploadSucceededEvent<FileStorageUploadField> event) {
        var file = refersFileService.saveRefersFile(event.getReceiver(), getRefersId());
        if (Objects.nonNull(file.getRefersFile())) {
            var useAgreement = getEditedEntity();
            useAgreement.setAgreement(file.getRefersFile());
            fileField.setValue(file.getFileRef());
        }
    }

    @Subscribe("fileField")
    public void onFileFieldComponentValueChange(final AbstractField.ComponentValueChangeEvent<FileStorageUploadField, ?> event) {
        if (Objects.nonNull(event.getOldValue())) {
            refersFileService.removeRefersFile((FileRef) event.getOldValue(), getRefersId());
        }
    }

    private UUID getRefersId() {
        var useAgreement = getEditedEntity();
        return useAgreement.getAgreement() != null ? useAgreement.getAgreement().getId() : null;
    }
}